#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

from datetime import datetime
from .nonetypevalue import get_none_value_by_type
from tango import AttrQuality


def fire_events(device, attribute_name, attribute_value,
                timestamp=None, quality=None, data_type=None):
    """
Interface method to unify the way the tango device fires the attribute events

:param device: a tango device
:param attribute_name: string with the name
:param attribute_value: value with the proper cast
:param timestamp: epoc time
:param quality: tango quality
:param data_type: tango type of the attribute to fire the event.
:return: None
    """
    if timestamp is None:
        timestamp = float(datetime.now().strftime('%s.%f'))
    if quality is None:
        if attribute_value is None:
            quality = AttrQuality.ATTR_INVALID
            attribute_value = get_none_value_by_type(data_type)
        else:
            quality = AttrQuality.ATTR_VALID
    device.push_change_event(attribute_name, attribute_value,
                             timestamp, quality)
    device.push_archive_event(attribute_name, attribute_value,
                              timestamp, quality)
